from time import sleep, time
from subprocess import *
import re

# based on an example from Chih-Heng Ke
# http://csie.nqu.edu.tw/smallko/sdn/monitor_qlen.htm

default_dir = '.'
 
def monitor_qlen(interval_sec=0.01):
  pat_queued =re.compile(r'backlog\s[^\s]+\s([\d]+)p')
  # tc -s -d qdisc ls dev r1-eth2
  cmd = "tc -s qdisc show dev r1-eth2"
  ret = []
  open("qlen.txt","w").write('')
  t0 = "%f" % time()
  while 1: 
    p = Popen(cmd, shell=True, stdout=PIPE)
    output = p.stdout.read()
    matches = pat_queued.findall(output.decode('utf-8'))
    if matches and len(matches) > 1:
      ret.append(matches[1])
      t1 = "%f" % time()
      open("qlen.txt","a").write(str(float(t1)-float(t0))+' '+str(float(t1))+' '+matches[1]+'\n')
    sleep(interval_sec)
 
monitor_qlen()

